Package net.sf.saxon.expr.flwor

## Class ClauseInfo

- java.lang.Object
- - net.sf.saxon.expr.flwor.ClauseInfo

- All Implemented Interfaces:
    `Locatable`, `Traceable`

      public class ClauseInfo
      extends java.lang.Object
      implements Traceable

  A "trace" clause in a FLWOR expression, added by a TraceCodeInjector

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClauseInfo​(Clause clause)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Clause` | `getClause()` | Get the clause being traced
    `int` | `getColumnNumber()` | Return the column number where the current document event ends.
    `int` | `getLineNumber()` | Get the line number of the instruction in the source stylesheet module.
    `Location` | `getLocation()` | Get the location of the construct
    `NamespaceResolver` | `getNamespaceResolver()` | Get the namespace bindings from the static context of the clause
    `StructuredQName` | `getObjectName()` | Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `java.lang.String` | `getPublicId()` | Return the public identifier for the current document event.
    `java.lang.String` | `getSystemId()` | Get the system identifier (URI) of the source stylesheet or query module containing the instruction.
    `void` | `setNamespaceResolver​(NamespaceResolver nsResolver)` | Set the namespace bindings from the static context of the clause

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### ClauseInfo

          public ClauseInfo​(Clause clause)

  - ### Method Detail

    - #### getClause

          public Clause getClause()

      Get the clause being traced
      Returns:
        the clause in the FLWOR expression to which this ClauseInfo relates

    - #### getLocation

          public Location getLocation()

      Description copied from interface: `Locatable`
      Get the location of the construct
      Specified by:
        `getLocation` in interface `Locatable`
      Returns:
        the location. If no location information is available, the method should return `Loc.NONE` rather than returning null. However, callers would be well advised to check for the result being null.

    - #### getObjectName

          public StructuredQName getObjectName()

      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.
      Specified by:
        `getObjectName` in interface `Traceable`
      Returns:
        the QName of the object declared or manipulated by this instruction or expression

    - #### getNamespaceResolver

          public NamespaceResolver getNamespaceResolver()

      Get the namespace bindings from the static context of the clause
      Returns:
        a namespace resolver that reflects the in scope namespaces of the clause

    - #### setNamespaceResolver

          public void setNamespaceResolver​(NamespaceResolver nsResolver)

      Set the namespace bindings from the static context of the clause
      Parameters:
        `nsResolver` - a namespace resolver that reflects the in scope namespaces of the clause

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system identifier (URI) of the source stylesheet or query module containing the instruction. This will generally be an absolute URI. If the system identifier is not known, the method may return null. In some cases, for example where XML external entities are used, the correct system identifier is not always retained.
      Returns:
        the URI of the containing module

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the instruction in the source stylesheet module. If this is not known, or if the instruction is an artificial one that does not relate to anything in the source code, the value returned may be -1.
      Returns:
        the line number of the expression within the containing module

    - #### getPublicId

          public java.lang.String getPublicId()

      Return the public identifier for the current document event.

      The return value is the public identifier of the document entity or of the external parsed entity in which the markup triggering the event appears.

      Returns:
        A string containing the public identifier, or null if none is available.
      See Also:
        `getSystemId()`

    - #### getColumnNumber

          public int getColumnNumber()

      Return the column number where the current document event ends. This is one-based number of Java `char` values since the last line end.

      Warning: The return value from the method is intended only as an approximation for the sake of diagnostics; it is not intended to provide sufficient information to edit the character content of the original XML document. For example, when lines contain combining character sequences, wide characters, surrogate pairs, or bi-directional text, the value may not correspond to the column in a text editor's display.

      The return value is an approximation of the column number in the document entity or external parsed entity where the markup triggering the event appears.

      If possible, the SAX driver should provide the line position of the first character after the text associated with the document event. The first column in each line is column 1.

      Returns:
        The column number, or -1 if none is available.
      See Also:
        `getLineNumber()`